
#    application: image filtering
#    state: experimental
#    revision: $Id: common_head.mk,v 1.3 2005/06/29 15:52:25 tobias Exp $
# 
#    Metaprogramming Project
#    Authors: Christoph A. Herrmann and Tobias Langhammer
#    University of Passau, Department of Informatics, Chair of Programming

##############################################################################
#
# Copyright (C) 2005 University of Passau, Department of Informatics
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

#### main configuration section #############################################
#
# adept the following definitions to your needs
# 

CC=gcc


# you may set OCAMLROOT in the system environment.
ifndef OCAMLROOT
# guess OCAMLROOT...
  path:=$(shell which ocamlc)
  path:=$(path:%/bin/ocamlc=%)
  OCAMLROOT=$(path)
  
# to set a default path by hand replace last couple with this:
#OCAMLROOT=/usr/local
endif

# pathes of executables
OCAMLC     := $(OCAMLROOT)/bin/ocamlc
OCAMLOPT   := $(OCAMLROOT)/bin/ocamlopt
OCAML      := $(OCAMLROOT)/bin/ocaml
OCAMLCP    := $(OCAMLROOT)/bin/ocamlcp
OCAMLPROF  := $(OCAMLROOT)/bin/ocamlprof
OCAMLYACC  := $(OCAMLROOT)/bin/ocamlyacc
OCAMLLEX   := $(OCAMLROOT)/bin/ocamllex
METAOCAML  := $(OCAMLROOT)/bin/metaocaml
METAOCAMLC := $(shell if [ -x $(OCAMLROOT)/bin/metaocamlc ] ; \
                      then echo $(OCAMLROOT)/bin/metaocamlc; \
		      else echo $(OCAMLC); fi)
OCAMLDOC   := $(OCAMLROOT)/bin/ocamldoc
OCAMLDEP   := $(OCAMLROOT)/bin/ocamldep

# Note: metaocamlopt is not available in current public release of 
# MetaOCaml (i.e. version 3.08)
METAOCAMLOPT=$(OCAMLROOT)/bin/metaocamlopt $(OCAMLFLAGS)


OCAMLFLAGS=-pp m4

# generator for make-dependencies
#
# ocamldep does not work yet in MetaOCaml Version 3.08
# this is a workaround:
#OCAMLDEP=./metaocamldep


OCAMLINC=-I $(OCAMLROOT)/lib/


############### end of configuration section ################################
#
# no manual configuration should be needed beyond this point


OCAMLDOC := $(OCAMLDOC) -pp remove_mo_syntax.sh

METAINC = toplevellib.cma

CMO_FILES=\
	  defs.cmo \
	  ppm.cmo \
	  filt_parser.cmo \
	  filt_lexer.cmo  \
	  timing.cmo \
	  unstagedinter.cmo \
	  staticeval.cmo \
	  stagedinter.cmo \
	  filt_config.cmo \
	  main.cmo


TEST_FILES = test_inter.ml test_inter.expect


CMI_FILES          = $(CMO_FILES:%.cmo=%.cmi)
CMX_FILES          = $(CMO_FILES:%.cmo=%.cmx)
ML_FILES           = $(CMO_FILES:%.cmo=%.ml) 
MLI_FILES          = $(filter-out filt_lexer.mli main.mli,$(ML_FILES:%.ml=%.mli))
M4_FILES           = config.m4 config_staged.m4 config_unstaged.m4

O_FILES_COMMON=$(CMX_FILES:%.cmx=%.o)


GENERATED_FILES=\
		deps\
		*.cmx\
		*.cmi\
		*.cmo\
		*.ml\
		*.mli\
		*.o\
		test_inter.expect\
		*.m4
#		filt_config_unstaged.ml \
#		filt_config_unstaged.mli \
#		filt_config.ml \
#		main.ml \



