(*

  application: image filtering
  state: experimental
  revision: $Id: filt_config.mli,v 1.2 2005/06/21 11:39:41 tobias Exp $
 
  Metaprogramming Project
  Authors: Christoph A. Herrmann and Tobias Langhammer
  University of Passau, Department of Informatics, Chair of Programming

 Copyright (C) 2004    University of Passau, Department of Informatics
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*)

type mode = Normal | Benchmark of (int * (int -> int))


type compilation = (int * int) -> Ppm.point
type config = { 
  mode:mode;
  ic:in_channel;
  oc:out_channel;
  osuffix:string option;
  iter_indep: bool;
  staged:bool;
  simplify:bool;
  max_unrolling: int;
  simplifyer: Ppm.image -> int -> Defs.top_exp -> Defs.top_exp;
  compiler: Ppm.image -> int -> Defs.top_exp -> compilation;
  time_simplify : bool;
  time_codegen : bool;
  time_bang : bool;
  time_exec : bool;
  iter:int;
  timings_iter:int;
  margintop:int;
  marginbottom:int;
  marginleft:int;
  marginright:int;
  print: int -> string Lazy.t -> unit;
  prerr: int -> string Lazy.t -> unit;
  formula:string;
  label:string;
}


val get : unit -> config
val finalize : config -> unit
