(*

  application: image filtering
  state: experimental
  revision: $Id: timing.mli,v 1.1.1.1 2005/06/17 08:56:18 tobias Exp $
 
  Metaprogramming Project
  Authors: Christoph A. Herrmann and Tobias Langhammer
  University of Passau, Department of Informatics, Chair of Programming

 Copyright (C) 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004 
    Institut National de Recherche en Informatique et en Automatique (INRIA)
 Copyright (C) 2004    University of Passau, Department of Informatics
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Library General Public License for more details.
 
  You should have received a copy of the GNU Library General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*)

(* time n s f   executes f() n times and records message s plus elapsed time *)
val time : int -> string -> (unit -> 'a) -> 'a
(* like time but timings are done only if first arg is true *)
val time_cond : bool -> int -> string -> (unit -> 'a) -> 'a
val timenew : string -> (unit -> 'a) -> 'a
(* like timenew but timings are done only if first arg is true *)
val timenew_cond : bool -> string -> (unit -> 'a) -> 'a
val init_times : unit -> unit
(* flushes recorded times *)
val print_times : unit -> unit

